diff -urN ../VisualBoyAdvance-1.7.2/src/GBA.cpp ./src/GBA.cpp
--- ../VisualBoyAdvance-1.7.2/src/GBA.cpp	2004-05-13 23:37:59 +0900
+++ ./src/GBA.cpp	2006-08-25 23:13:38 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -42,32 +42,51 @@
 #include "prof/prof.h"
 #endif
 
-#define UPDATE_REG(address, value) WRITE16LE(((u16 *)&ioMem[address]),value)
+#define UPDATE_REG(address, value)\
+  {\
+    WRITE16LE(((u16 *)&ioMem[address]),value);\
+  }\
+
+#define ARM_PREFETCH \
+  {\
+    cpuPrefetch[0] = CPUReadMemoryQuick(armNextPC);\
+    cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);\
+  }
+
+#define THUMB_PREFETCH \
+  {\
+    cpuPrefetch[0] = CPUReadHalfWordQuick(armNextPC);\
+    cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);\
+  }
+
+#define ARM_PREFETCH_NEXT \
+  cpuPrefetch[1] = CPUReadMemoryQuick(armNextPC+4);
+
+#define THUMB_PREFETCH_NEXT\
+  cpuPrefetch[1] = CPUReadHalfWordQuick(armNextPC+2);
 
 #ifdef __GNUC__
 #define _stricmp strcasecmp
 #endif
 
-#define CPU_BREAK_LOOP \
-  cpuSavedTicks = cpuSavedTicks - *extCpuLoopTicks;\
-  *extCpuLoopTicks = *extClockTicks;
-
-#define CPU_BREAK_LOOP_2 \
-  cpuSavedTicks = cpuSavedTicks - *extCpuLoopTicks;\
-  *extCpuLoopTicks = *extClockTicks;\
-  *extTicks = *extClockTicks;
 
 extern int emulating;
+int SWITicks = 0;
+int IRQTicks = 0;
 
+u32 mastercode = 0;
+int layerEnableDelay = 0;
+bool busPrefetch = false;
+bool busPrefetchEnable = false;
+u32 busPrefetchCount = 0;
 int cpuDmaTicksToUpdate = 0;
 int cpuDmaCount = 0;
-bool cpuDmaHack = 0;
+bool cpuDmaHack = false;
 u32 cpuDmaLast = 0;
 int dummyAddress = 0;
 
-int *extCpuLoopTicks = NULL;
-int *extClockTicks = NULL;
-int *extTicks = NULL;
+bool cpuBreakLoop = false;
+int cpuNextEvent = 0;
 
 int gbaSaveType = 0; // used to remember the save type on reset
 bool intState = false;
@@ -79,29 +98,42 @@
 bool cpuEEPROMEnabled = true;
 bool cpuEEPROMSensorEnabled = false;
 
+u32 cpuPrefetch[2];
+
+int cpuTotalTicks = 0;
 #ifdef PROFILING
 int profilingTicks = 0;
 int profilingTicksReload = 0;
-static char *profilBuffer = NULL;
-static int profilSize = 0;
-static u32 profilLowPC = 0;
-static int profilScale = 0;
-#endif
-bool freezeWorkRAM[0x40000];
-bool freezeInternalRAM[0x8000];
-int lcdTicks = 960;
+static profile_segment *profilSegment = NULL;
+#endif
+
+#ifdef BKPT_SUPPORT
+u8 freezeWorkRAM[0x40000];
+u8 freezeInternalRAM[0x8000];
+u8 freezeVRAM[0x18000];
+u8 freezePRAM[0x400];
+u8 freezeOAM[0x400];
+bool debugger_last;
+#endif
+
+int lcdTicks = (useBios && !skipBios) ? 1008 : 208;
+u8 timerOnOffDelay = 0;
+u16 timer0Value = 0;
 bool timer0On = false;
 int timer0Ticks = 0;
 int timer0Reload = 0;
 int timer0ClockReload  = 0;
+u16 timer1Value = 0;
 bool timer1On = false;
 int timer1Ticks = 0;
 int timer1Reload = 0;
 int timer1ClockReload  = 0;
+u16 timer2Value = 0;
 bool timer2On = false;
 int timer2Ticks = 0;
 int timer2Reload = 0;
 int timer2ClockReload  = 0;
+u16 timer3Value = 0;
 bool timer3On = false;
 int timer3Ticks = 0;
 int timer3Reload = 0;
@@ -129,62 +161,38 @@
 int captureNumber = 0;
 
 const int TIMER_TICKS[4] = {
-  1,
-  64,
-  256,
-  1024
-};
-
-const int thumbCycles[] = {
-//  0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
-    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 0
-    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 1
-    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 2
-    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  // 3
-    1, 1, 1, 1, 1, 1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 3,  // 4
-    2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,  // 5
-    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,  // 6
-    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,  // 7
-    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,  // 8
-    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,  // 9
-    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,  // a
-    1, 1, 1, 1, 2, 2, 1, 1, 1, 1, 1, 1, 2, 4, 1, 1,  // b
-    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,  // c
-    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 3,  // d
-    3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,  // e
-    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2   // f
+  0,
+  6,
+  8,
+  10
 };
 
-const int gamepakRamWaitState[4] = { 4, 3, 2, 8 };
-const int gamepakWaitState[8] =  { 4, 3, 2, 8, 4, 3, 2, 8 };
-const int gamepakWaitState0[8] = { 2, 2, 2, 2, 1, 1, 1, 1 };
-const int gamepakWaitState1[8] = { 4, 4, 4, 4, 1, 1, 1, 1 };
-const int gamepakWaitState2[8] = { 8, 8, 8, 8, 1, 1, 1, 1 };
+const u32  objTilesAddress [3] = {0x010000, 0x014000, 0x014000};
+const u8 gamepakRamWaitState[4] = { 4, 3, 2, 8 };
+const u8 gamepakWaitState[4] =  { 4, 3, 2, 8 };
+const u8 gamepakWaitState0[2] = { 2, 1 };
+const u8 gamepakWaitState1[2] = { 4, 1 };
+const u8 gamepakWaitState2[2] = { 8, 1 };
+const bool isInRom [16]=
+  { false, false, false, false, false, false, false, false,
+    true, true, true, true, true, true, false, false };              
 
-int memoryWait[16] =
+u8 memoryWait[16] =
   { 0, 0, 2, 0, 0, 0, 0, 0, 4, 4, 4, 4, 4, 4, 4, 0 };
-int memoryWait32[16] =
-  { 0, 0, 9, 0, 0, 0, 0, 0, 8, 8, 8, 8, 8, 8, 8, 0 };
-int memoryWaitSeq[16] =
+u8 memoryWait32[16] =
+  { 0, 0, 5, 0, 0, 1, 1, 0, 7, 7, 9, 9, 13, 13, 4, 0 };
+u8 memoryWaitSeq[16] =
   { 0, 0, 2, 0, 0, 0, 0, 0, 2, 2, 4, 4, 8, 8, 4, 0 };
-int memoryWaitSeq32[16] =
-  { 2, 0, 3, 0, 0, 2, 2, 0, 4, 4, 8, 8, 16, 16, 8, 0 };
-int memoryWaitFetch[16] =
-  { 3, 0, 3, 0, 0, 1, 1, 0, 4, 4, 4, 4, 4, 4, 4, 0 };
-int memoryWaitFetch32[16] =
-  { 6, 0, 6, 0, 0, 2, 2, 0, 8, 8, 8, 8, 8, 8, 8, 0 };
-
-const int cpuMemoryWait[16] = {
-  0, 0, 2, 0, 0, 0, 0, 0,
-  2, 2, 2, 2, 2, 2, 0, 0
-};
-const int cpuMemoryWait32[16] = {
-  0, 0, 3, 0, 0, 0, 0, 0,
-  3, 3, 3, 3, 3, 3, 0, 0
-};
-  
-const bool memory32[16] =
-  { true, false, false, true, true, false, false, true, false, false, false, false, false, false, true, false};
+u8 memoryWaitSeq32[16] =
+  { 0, 0, 5, 0, 0, 1, 1, 0, 5, 5, 9, 9, 17, 17, 4, 0 };
+
+// The videoMemoryWait constants are used to add some waitstates
+// if the opcode access video memory data outside of vblank/hblank
+// It seems to happen on only one ticks for each pixel.
+// Not used for now (too problematic with current code).
+//const u8 videoMemoryWait[16] =
+//  {0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0};
+
 
 u8 biosProtected[4];
 
@@ -320,7 +328,6 @@
 0xE3A00001,
 0xE3A01001,
 0xE92D4010,
-0xE3A0C301,
 0xE3A03000,
 0xE3A04001,
 0xE3500000,
@@ -330,11 +337,12 @@
 0x0AFFFFFC,
 0xE8BD4010,
 0xE12FFF1E,
+0xE3A0C301,
 0xE5CC3208,
 0xE15C20B8,
 0xE0110002,
-0x10200002,
-0x114C00B8,
+0x10222000,
+0x114C20B8,
 0xE5CC4208,
 0xE12FFF1E,
 0xE92D500F,
@@ -487,16 +495,12 @@
   { NULL, 0 } 
 };
 
-//int cpuLoopTicks = 0;
-int cpuSavedTicks = 0;
+static int romSize = 0x2000000;
 
 #ifdef PROFILING
-void cpuProfil(char *buf, int size, u32 lowPC, int scale)
+void cpuProfil(profile_segment *seg)
 {
-  profilBuffer = buf;
-  profilSize = size;
-  profilLowPC = lowPC;
-  profilScale = scale;
+    profilSegment = seg;
 }
 
 void cpuEnableProfiling(int hz)
@@ -508,26 +512,211 @@
 }
 #endif
 
-inline int CPUUpdateTicksAccess32(u32 address)
+
+// Waitstates when accessing data
+inline int dataTicksAccess16(u32 address) // DATA 8/16bits NON SEQ
 {
-  return memoryWait32[(address>>24)&15];
+  int addr = (address>>24)&15;
+  int value =  memoryWait[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
+  }
+
+  return value;
 }
 
-inline int CPUUpdateTicksAccess16(u32 address)
+inline int dataTicksAccess32(u32 address) // DATA 32bits NON SEQ
 {
-  return memoryWait[(address>>24)&15];
+  int addr = (address>>24)&15;
+  int value = memoryWait32[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
+  }
+
+  return value;
 }
 
-inline int CPUUpdateTicksAccessSeq32(u32 address)
+inline int dataTicksAccessSeq16(u32 address)// DATA 8/16bits SEQ
 {
-  return memoryWaitSeq32[(address>>24)&15];
+  int addr = (address>>24)&15;
+  int value = memoryWaitSeq[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
+  }
+
+  return value;
 }
 
-inline int CPUUpdateTicksAccessSeq16(u32 address)
+inline int dataTicksAccessSeq32(u32 address)// DATA 32bits SEQ
+{
+  int addr = (address>>24)&15;
+  int value =  memoryWaitSeq32[addr];
+
+  if ((addr>=0x08) || (addr < 0x02))
+  {
+    busPrefetchCount=0;
+    busPrefetch=false;
+  }
+  else if (busPrefetch)
+  {
+    int waitState = value;
+    if (!waitState)
+      waitState = 1;
+    busPrefetchCount = ((++busPrefetchCount)<<waitState) - 1;
+  }
+
+  return value;
+}
+
+
+// Waitstates when executing opcode
+inline int codeTicksAccess16(u32 address) // THUMB NON SEQ
 {
-  return memoryWaitSeq[(address>>24)&15];
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr]-1;
+    }
+    else
+    {
+      busPrefetchCount=0;
+      return memoryWait[addr];
+    }
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWait[addr];
+  }
+}
+
+inline int codeTicksAccess32(u32 address) // ARM NON SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr] - 1;
+    }
+    else
+    {
+      busPrefetchCount = 0;
+      return memoryWait32[addr];
+    }
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWait32[addr];
+  }
+}
+
+inline int codeTicksAccessSeq16(u32 address) // THUMB SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return 0;
+    }
+    else
+    if (busPrefetchCount>0xFF)
+    {
+      busPrefetchCount=0;
+      return memoryWait[addr];
+    }
+    else
+      return memoryWaitSeq[addr];
+  }
+  else
+  {
+    busPrefetchCount = 0;
+    return memoryWaitSeq[addr];
+  }
+}
+
+inline int codeTicksAccessSeq32(u32 address) // ARM SEQ
+{
+  int addr = (address>>24)&15;
+
+  if ((addr>=0x08) && (addr<=0x0D))
+  {
+    if (busPrefetchCount&0x1)
+    {
+      if (busPrefetchCount&0x2)
+      {
+        busPrefetchCount = ((busPrefetchCount&0xFF)>>2) | (busPrefetchCount&0xFFFFFF00);
+        return 0;
+      }
+      busPrefetchCount = ((busPrefetchCount&0xFF)>>1) | (busPrefetchCount&0xFFFFFF00);
+      return memoryWaitSeq[addr];
+    }
+    else
+    if (busPrefetchCount>0xFF)
+    {
+      busPrefetchCount=0;
+      return memoryWait32[addr];
+    }
+    else
+      return memoryWaitSeq32[addr];
+  }
+  else
+  {
+    return memoryWaitSeq32[addr];
+  }
 }
 
+
 inline int CPUUpdateTicks()
 {
   int cpuLoopTicks = lcdTicks;
@@ -535,7 +724,7 @@
   if(soundTicks < cpuLoopTicks)
     cpuLoopTicks = soundTicks;
   
-  if(timer0On && !(TM0CNT & 4) && (timer0Ticks < cpuLoopTicks)) {
+  if(timer0On && (timer0Ticks < cpuLoopTicks)) {
     cpuLoopTicks = timer0Ticks;
   }
   if(timer1On && !(TM1CNT & 4) && (timer1Ticks < cpuLoopTicks)) {
@@ -554,7 +743,17 @@
     }
   }
 #endif
-  cpuSavedTicks = cpuLoopTicks;
+
+  if (SWITicks) {
+    if (SWITicks < cpuLoopTicks)
+        cpuLoopTicks = SWITicks;
+  }
+
+  if (IRQTicks) {
+    if (IRQTicks < cpuLoopTicks)
+        cpuLoopTicks = IRQTicks;
+  }
+
   return cpuLoopTicks;
 }
 
@@ -634,7 +833,7 @@
   // new to version 0.7.1
   utilWriteInt(gzFile, stopState);
   // new to version 0.8
-  utilWriteInt(gzFile, intState);
+  utilWriteInt(gzFile, IRQTicks);
 
   utilGzWrite(gzFile, internalRAM, 0x8000);
   utilGzWrite(gzFile, paletteRAM, 0x400);
@@ -738,9 +937,21 @@
     stopState = utilReadInt(gzFile) ? true : false;
 
   if(version < SAVE_GAME_VERSION_4)
+  {
+    IRQTicks = 0;
     intState = false;
+  }
   else
-    intState = utilReadInt(gzFile) ? true : false;
+  {
+    IRQTicks = utilReadInt(gzFile);
+    if (IRQTicks>0)
+      intState = true;
+    else
+    {
+      intState = false;
+      IRQTicks = 0;
+    }
+  }
   
   utilGzRead(gzFile, internalRAM, 0x8000);
   utilGzRead(gzFile, paletteRAM, 0x400);
@@ -758,7 +969,7 @@
   soundReadGame(gzFile, version);
   
   if(version > SAVE_GAME_VERSION_1) {
-    cheatsReadGame(gzFile);
+    cheatsReadGame(gzFile, version);
   }
   if(version > SAVE_GAME_VERSION_6) {
     rtcReadGame(gzFile);
@@ -782,6 +993,18 @@
     SWAP(dma3Dest,   DM3DAD_H, DM3DAD_L);
   }
 
+  if(version <= SAVE_GAME_VERSION_8) {
+    timer0ClockReload = TIMER_TICKS[TM0CNT & 3]; 
+    timer1ClockReload = TIMER_TICKS[TM1CNT & 3];
+    timer2ClockReload = TIMER_TICKS[TM2CNT & 3];
+    timer3ClockReload = TIMER_TICKS[TM3CNT & 3];
+
+    timer0Ticks = ((0x10000 - TM0D) << timer0ClockReload) - timer0Ticks;
+    timer1Ticks = ((0x10000 - TM1D) << timer1ClockReload) - timer1Ticks;
+    timer2Ticks = ((0x10000 - TM2D) << timer2ClockReload) - timer2Ticks;
+    timer3Ticks = ((0x10000 - TM3D) << timer3ClockReload) - timer3Ticks;
+  }
+
   // set pointers!
   layerEnable = layerSettings & DISPCNT;
   
@@ -802,6 +1025,11 @@
     cpuSaveGameFunc = flashWrite;
     gbaSaveType = 2;
     break;
+  case 3:
+     break;
+  case 5:
+    gbaSaveType = 5;
+    break;
   default:
     systemMessage(MSG_UNSUPPORTED_SAVE_TYPE,
                   N_("Unsupported save type %d"), saveType);
@@ -811,6 +1039,13 @@
     gbaSaveType = 3;
 
   systemSaveUpdateCounter = SYSTEM_SAVE_NOT_UPDATED;
+  if(armState) {
+    ARM_PREFETCH;
+  } else {
+    THUMB_PREFETCH;
+  }
+
+  CPUUpdateRegister(0x204, CPUReadHalfWordQuick(0x4000204));
   
   return true;  
 }
@@ -880,7 +1115,7 @@
     }
   }
   
-  if(gbaSaveType) {
+  if((gbaSaveType) && (gbaSaveType!=5)) {
     FILE *file = fopen(fileName, "wb");
     
     if(!file) {
@@ -997,13 +1232,13 @@
   fwrite("SharkPortSave", 1, 0x0d, file);
   utilPutDword(buffer, 0x000f0000);
   fwrite(buffer, 1, 4, file); // save type 0x000f0000 = GBA save
-  utilPutDword(buffer, strlen(title));
+  utilPutDword(buffer, (u32)strlen(title));
   fwrite(buffer, 1, 4, file); // title length
   fwrite(title, 1, strlen(title), file);
-  utilPutDword(buffer, strlen(desc));
+  utilPutDword(buffer, (u32)strlen(desc));
   fwrite(buffer, 1, 4, file); // desc length
   fwrite(desc, 1, strlen(desc), file);
-  utilPutDword(buffer, strlen(notes));
+  utilPutDword(buffer, (u32)strlen(notes));
   fwrite(buffer, 1, 4, file); // notes length
   fwrite(notes, 1, strlen(notes), file);
   int saveSize = 0x10000;
@@ -1130,7 +1365,7 @@
 bool CPUIsZipFile(const char * file)
 {
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".zip") == 0)
@@ -1145,7 +1380,7 @@
 {
   cpuIsMultiBoot = false;
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".gba") == 0)
@@ -1169,7 +1404,7 @@
 bool CPUIsGBABios(const char * file)
 {
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
 
     if(p != NULL) {
       if(_stricmp(p, ".gba") == 0)
@@ -1189,7 +1424,7 @@
 bool CPUIsELF(const char *file)
 {
   if(strlen(file) > 4) {
-    char * p = strrchr(file,'.');
+    const char * p = strrchr(file,'.');
     
     if(p != NULL) {
       if(_stricmp(p, ".elf") == 0)
@@ -1261,8 +1496,7 @@
 
 int CPULoadRom(const char *szFile)
 {
-  int size = 0x2000000;
-  
+  romSize = 0x2000000;
   if(rom != NULL) {
     CPUCleanUp();
   }
@@ -1297,8 +1531,8 @@
       workRAM = NULL;
       return 0;
     }
-    bool res = elfRead(szFile, size, f);
-    if(!res || size == 0) {
+    bool res = elfRead(szFile, romSize, f);
+    if(!res || romSize == 0) {
       free(rom);
       rom = NULL;
       free(workRAM);
@@ -1309,7 +1543,7 @@
   } else if(!utilLoad(szFile,
                       utilIsGBAImage,
                       whereToLoad,
-                      size)) {
+                      romSize)) {
     free(rom);
     rom = NULL;
     free(workRAM);
@@ -1317,9 +1551,9 @@
     return 0;
   }
 
-  u16 *temp = (u16 *)(rom+((size+1)&~1));
+  u16 *temp = (u16 *)(rom+((romSize+1)&~1));
   int i;
-  for(i = (size+1)&~1; i < 0x2000000; i+=2) {
+  for(i = (romSize+1)&~1; i < 0x2000000; i+=2) {
     WRITE16LE(temp, (i >> 1) & 0xFFFF);
     temp++;
   }
@@ -1374,9 +1608,29 @@
     return 0;
   }      
 
+  flashInit();
+  eepromInit();
+
   CPUUpdateRenderBuffers(true);
 
-  return size;
+  return romSize;
+}
+
+void doMirroring (bool b)
+{
+  u32 mirroredRomSize = (((romSize)>>20) & 0x3F)<<20;
+  u32 mirroredRomAddress = romSize;
+  if ((mirroredRomSize <=0x800000) && (b))
+  {
+    mirroredRomAddress = mirroredRomSize;
+    if (mirroredRomSize==0)
+        mirroredRomSize=0x100000;
+    while (mirroredRomAddress<0x01000000)
+    {
+      memcpy ((u16 *)(rom+mirroredRomAddress), (u16 *)(rom), mirroredRomSize);
+      mirroredRomAddress+=mirroredRomSize;
+    }
+  }
 }
 
 void CPUUpdateRender()
@@ -1470,9 +1724,8 @@
   armState = (CPSR & 0x20) ? false : true;
   armIrqEnable = (CPSR & 0x80) ? false : true;
   if(breakLoop) {
-    if(armIrqEnable && (IF & IE) && (IME & 1)) {
-      CPU_BREAK_LOOP_2;
-    }
+      if (armIrqEnable && (IF & IE) && (IME & 1))
+        cpuNextEvent = cpuTotalTicks;
   }
 }
 
@@ -1626,6 +1879,7 @@
   armState = true;
   armIrqEnable = false;
   armNextPC = 0x04;
+  ARM_PREFETCH;
   reg[15].I += 4;  
 }
 
@@ -1639,6 +1893,7 @@
   armState = true;
   armIrqEnable = false;
   armNextPC = 0x08;
+  ARM_PREFETCH;
   reg[15].I += 4;
 }
 
@@ -1678,7 +1933,8 @@
 #ifdef SDL
   if(comment == 0xf9) {
     emulating = 0;
-    CPU_BREAK_LOOP_2;
+    cpuNextEvent = cpuTotalTicks;
+    cpuBreakLoop = true;
     return;
   }
 #endif
@@ -1704,6 +1960,7 @@
   switch(comment) {
   case 0x00:
     BIOS_SoftReset();
+    ARM_PREFETCH;
     break;
   case 0x01:
     BIOS_RegisterRamReset();
@@ -1717,6 +1974,7 @@
 #endif    
     holdState = true;
     holdType = -1;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x03:
 #ifdef DEV_VERSION
@@ -1728,6 +1986,7 @@
     holdState = true;
     holdType = -1;
     stopState = true;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x04:
 #ifdef DEV_VERSION
@@ -1765,11 +2024,52 @@
     BIOS_ArcTan2();
     break;
   case 0x0B:
+    {
+      int len = (reg[2].I & 0x1FFFFF) >>1;
+      if (!(((reg[0].I & 0xe000000) == 0) ||
+         ((reg[0].I + len) & 0xe000000) == 0))
+      {
+        if ((reg[2].I >> 24) & 1)
+        {
+          if ((reg[2].I >> 26) & 1) 
+          SWITicks = (7 + memoryWait32[(reg[1].I>>24) & 0xF]) * (len>>1);
+          else
+          SWITicks = (8 + memoryWait[(reg[1].I>>24) & 0xF]) * (len);
+        }
+        else
+        {
+          if ((reg[2].I >> 26) & 1) 
+          SWITicks = (10 + memoryWait32[(reg[0].I>>24) & 0xF] +
+              memoryWait32[(reg[1].I>>24) & 0xF]) * (len>>1);
+          else
+          SWITicks = (11 + memoryWait[(reg[0].I>>24) & 0xF] +
+              memoryWait[(reg[1].I>>24) & 0xF]) * len;
+        }
+      }
+    }
     BIOS_CpuSet();
     break;
   case 0x0C:
+    {
+      int len = (reg[2].I & 0x1FFFFF) >>5;
+      if (!(((reg[0].I & 0xe000000) == 0) ||
+         ((reg[0].I + len) & 0xe000000) == 0))
+      {
+        if ((reg[2].I >> 24) & 1)
+          SWITicks = (6 + memoryWait32[(reg[1].I>>24) & 0xF] +
+              7 * (memoryWaitSeq32[(reg[1].I>>24) & 0xF] + 1)) * len;
+        else
+          SWITicks = (9 + memoryWait32[(reg[0].I>>24) & 0xF] +
+              memoryWait32[(reg[1].I>>24) & 0xF] + 
+              7 * (memoryWaitSeq32[(reg[0].I>>24) & 0xF] +
+              memoryWaitSeq32[(reg[1].I>>24) & 0xF] + 2)) * len;
+      }
+    }
     BIOS_CpuFastSet();
     break;
+  case 0x0D:
+    BIOS_GetBiosChecksum();
+    break;
   case 0x0E:
     BIOS_BgAffineSet();
     break;
@@ -1777,30 +2077,89 @@
     BIOS_ObjAffineSet();
     break;
   case 0x10:
+    {
+      int len = CPUReadHalfWord(reg[2].I);
+      if (!(((reg[0].I & 0xe000000) == 0) ||
+         ((reg[0].I + len) & 0xe000000) == 0))
+        SWITicks = (32 + memoryWait[(reg[0].I>>24) & 0xF]) * len;
+    }
     BIOS_BitUnPack();
     break;
   case 0x11:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 8;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (9 + memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_LZ77UnCompWram();
     break;
   case 0x12:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 8;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (19 + memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_LZ77UnCompVram();
     break;
   case 0x13:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 8;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (29 + (memoryWait[(reg[0].I>>24) & 0xF]<<1)) * len;
+    }
     BIOS_HuffUnComp();
     break;
   case 0x14:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 8;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (11 + memoryWait[(reg[0].I>>24) & 0xF] +
+          memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_RLUnCompWram();
     break;
   case 0x15:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 9;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (34 + (memoryWait[(reg[0].I>>24) & 0xF] << 1) +
+          memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_RLUnCompVram();
     break;
   case 0x16:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 8;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (13 + memoryWait[(reg[0].I>>24) & 0xF] +
+          memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_Diff8bitUnFilterWram();
     break;
   case 0x17:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 9;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (39 + (memoryWait[(reg[0].I>>24) & 0xF]<<1) +
+          memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_Diff8bitUnFilterVram();
     break;
   case 0x18:
+    {
+      u32 len = CPUReadMemory(reg[0].I) >> 9;
+      if(!(((reg[0].I & 0xe000000) == 0) ||
+          ((reg[0].I + (len & 0x1fffff)) & 0xe000000) == 0))
+        SWITicks = (13 + memoryWait[(reg[0].I>>24) & 0xF] +
+          memoryWait[(reg[1].I>>24) & 0xF]) * len;
+    }
     BIOS_Diff16bitUnFilter();
     break;
   case 0x19:
@@ -1859,17 +2218,33 @@
     DISPSTAT &= 0xFFFB;
     UPDATE_REG(0x4, DISPSTAT);
   }
+  if (layerEnableDelay>0)
+  {
+      layerEnableDelay--;
+      if (layerEnableDelay==1)
+          layerEnable = layerSettings & DISPCNT;
+  }
+
 }
 
 void doDMA(u32 &s, u32 &d, u32 si, u32 di, u32 c, int transfer32)
 {
   int sm = s >> 24;
   int dm = d >> 24;
-
+  int sw = 0;
+  int dw = 0;
   int sc = c;
 
   cpuDmaCount = c;
+  // This is done to get the correct waitstates.
+  if (sm>15)
+      sm=15;
+  if (dm>15)
+      dm=15;
   
+  //if ((sm>=0x05) && (sm<=0x07) || (dm>=0x05) && (dm <=0x07))
+  //    blank = (((DISPSTAT | ((DISPSTAT>>1)&1))==1) ?  true : false);
+
   if(transfer32) {
     s &= 0xFFFFFFFC;
     if(s < 0x02000000 && (reg[15].I >> 24)) {
@@ -1880,7 +2255,8 @@
       }
     } else {
       while(c != 0) {
-        CPUWriteMemory(d, CPUReadMemory(s));
+        cpuDmaLast = CPUReadMemory(s);
+        CPUWriteMemory(d, cpuDmaLast);
         d += di;
         s += si;
         c--;
@@ -1900,6 +2276,7 @@
       while(c != 0) {
         cpuDmaLast = CPUReadHalfWord(s);
         CPUWriteHalfWord(d, cpuDmaLast);
+        cpuDmaLast |= (cpuDmaLast<<16);
         d += di;
         s += si;
         c--;
@@ -1909,30 +2286,28 @@
 
   cpuDmaCount = 0;
   
-  int sw = 1+memoryWaitSeq[sm & 15];
-  int dw = 1+memoryWaitSeq[dm & 15];
-
   int totalTicks = 0;
 
   if(transfer32) {
-    if(!memory32[sm & 15])
-      sw <<= 1;
-    if(!memory32[dm & 15])
-      dw <<= 1;
+      sw =1+memoryWaitSeq32[sm & 15];
+      dw =1+memoryWaitSeq32[dm & 15];
+      totalTicks = (sw+dw)*(sc-1) + 6 + memoryWait32[sm & 15] +
+          memoryWaitSeq32[dm & 15];
+  }
+  else
+  {
+     sw = 1+memoryWaitSeq[sm & 15];
+     dw = 1+memoryWaitSeq[dm & 15];
+      totalTicks = (sw+dw)*(sc-1) + 6 + memoryWait[sm & 15] +
+          memoryWaitSeq[dm & 15];
   }
-  
-  totalTicks = (sw+dw)*sc;
 
   cpuDmaTicksToUpdate += totalTicks;
 
-  if(*extCpuLoopTicks >= 0) {
-    CPU_BREAK_LOOP;
-  }
 }
 
 void CPUCheckDMA(int reason, int dmamask)
 {
-  cpuDmaHack = 0;
   // DMA 0
   if((DM0CNT_H & 0x8000) && (dmamask & 1)) {
     if(((DM0CNT_H >> 12) & 3) == reason) {
@@ -1971,10 +2346,12 @@
       doDMA(dma0Source, dma0Dest, sourceIncrement, destIncrement,
             DM0CNT_L ? DM0CNT_L : 0x4000,
             DM0CNT_H & 0x0400);
-      cpuDmaHack = 1;
+      cpuDmaHack = true;
+
       if(DM0CNT_H & 0x4000) {
         IF |= 0x0100;
         UPDATE_REG(0x202, IF);
+        cpuNextEvent = cpuTotalTicks;
       }
       
       if(((DM0CNT_H >> 5) & 3) == 3) {
@@ -2038,11 +2415,12 @@
               DM1CNT_L ? DM1CNT_L : 0x4000,
               DM1CNT_H & 0x0400);
       }
-      cpuDmaHack = 1;
-        
+      cpuDmaHack = true;
+
       if(DM1CNT_H & 0x4000) {
         IF |= 0x0200;
         UPDATE_REG(0x202, IF);
+        cpuNextEvent = cpuTotalTicks;
       }
       
       if(((DM1CNT_H >> 5) & 3) == 3) {
@@ -2107,10 +2485,12 @@
               DM2CNT_L ? DM2CNT_L : 0x4000,
               DM2CNT_H & 0x0400);
       }
-      cpuDmaHack = 1;
+      cpuDmaHack = true;
+
       if(DM2CNT_H & 0x4000) {
         IF |= 0x0400;
         UPDATE_REG(0x202, IF);
+        cpuNextEvent = cpuTotalTicks;
       }
 
       if(((DM2CNT_H >> 5) & 3) == 3) {
@@ -2165,6 +2545,7 @@
       if(DM3CNT_H & 0x4000) {
         IF |= 0x0800;
         UPDATE_REG(0x202, IF);
+        cpuNextEvent = cpuTotalTicks;
       }
 
       if(((DM3CNT_H >> 5) & 3) == 3) {
@@ -2177,7 +2558,6 @@
       }
     }
   }
-  cpuDmaHack = 0;
 }
 
 void CPUUpdateRegister(u32 address, u16 value)
@@ -2185,15 +2565,27 @@
   switch(address) {
   case 0x00:
     {
+      if ((value & 7) >5)
+          DISPCNT = (value &7);
       bool change = ((DISPCNT ^ value) & 0x80) ? true : false;
       bool changeBG = ((DISPCNT ^ value) & 0x0F00) ? true : false;
+      u16 changeBGon = (((~DISPCNT) & value) & 0x0F00);
       DISPCNT = (value & 0xFFF7);
       UPDATE_REG(0x00, DISPCNT);
-      layerEnable = layerSettings & value;
+
+      if (changeBGon)
+      {
+         layerEnableDelay=4;
+         layerEnable = layerSettings & value & (~changeBGon);
+      }
+       else
+         layerEnable = layerSettings & value;
+      //      CPUUpdateTicks();
+
       windowOn = (layerEnable & 0x6000) ? true : false;
       if(change && !((value & 0x80))) {
         if(!(DISPSTAT & 1)) {
-          lcdTicks = 960;
+          lcdTicks = 1008;
           //      VCOUNT = 0;
           //      UPDATE_REG(0x06, VCOUNT);
           DISPSTAT &= 0xFFFC;
@@ -2206,7 +2598,6 @@
       // we only care about changes in BG0-BG3
       if(changeBG)
         CPUUpdateRenderBuffers(false);
-      //      CPUUpdateTicks();
     }
     break;
   case 0x04:
@@ -2554,70 +2945,37 @@
       }
     }
     break;
-  case 0x100:
+ case 0x100:
     timer0Reload = value;
     break;
   case 0x102:
-    timer0Ticks = timer0ClockReload = TIMER_TICKS[value & 3];        
-    if(!timer0On && (value & 0x80)) {
-      // reload the counter
-      TM0D = timer0Reload;      
-      if(timer0ClockReload == 1)
-        timer0Ticks = 0x10000 - TM0D;
-      UPDATE_REG(0x100, TM0D);
-    }
-    timer0On = value & 0x80 ? true : false;
-    TM0CNT = value & 0xC7;
-    UPDATE_REG(0x102, TM0CNT);
-    //    CPUUpdateTicks();
+    timer0Value = value;
+    timerOnOffDelay|=1;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x104:
     timer1Reload = value;
     break;
   case 0x106:
-    timer1Ticks = timer1ClockReload = TIMER_TICKS[value & 3];        
-    if(!timer1On && (value & 0x80)) {
-      // reload the counter
-      TM1D = timer1Reload;      
-      if(timer1ClockReload == 1)
-        timer1Ticks = 0x10000 - TM1D;
-      UPDATE_REG(0x104, TM1D);
-    }
-    timer1On = value & 0x80 ? true : false;
-    TM1CNT = value & 0xC7;
-    UPDATE_REG(0x106, TM1CNT);
+    timer1Value = value;
+    timerOnOffDelay|=2;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x108:
     timer2Reload = value;
     break;
   case 0x10A:
-    timer2Ticks = timer2ClockReload = TIMER_TICKS[value & 3];        
-    if(!timer2On && (value & 0x80)) {
-      // reload the counter
-      TM2D = timer2Reload;      
-      if(timer2ClockReload == 1)
-        timer2Ticks = 0x10000 - TM2D;
-      UPDATE_REG(0x108, TM2D);
-    }
-    timer2On = value & 0x80 ? true : false;
-    TM2CNT = value & 0xC7;
-    UPDATE_REG(0x10A, TM2CNT);
+    timer2Value = value;
+    timerOnOffDelay|=4;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x10C:
     timer3Reload = value;
     break;
   case 0x10E:
-    timer3Ticks = timer3ClockReload = TIMER_TICKS[value & 3];        
-    if(!timer3On && (value & 0x80)) {
-      // reload the counter
-      TM3D = timer3Reload;      
-      if(timer3ClockReload == 1)
-        timer3Ticks = 0x10000 - TM3D;
-      UPDATE_REG(0x10C, TM3D);
-    }
-    timer3On = value & 0x80 ? true : false;
-    TM3CNT = value & 0xC7;
-    UPDATE_REG(0x10E, TM3CNT);
+    timer3Value = value;
+    timerOnOffDelay|=8;
+    cpuNextEvent = cpuTotalTicks;
     break;
   case 0x128:
     if(value & 0x80) {
@@ -2641,9 +2999,8 @@
   case 0x200:
     IE = value & 0x3FFF;
     UPDATE_REG(0x200, IE);
-    if((IME & 1) && (IF & IE) && armIrqEnable) {
-      CPU_BREAK_LOOP_2;
-    }    
+    if ((IME & 1) && (IF & IE) && armIrqEnable)
+      cpuNextEvent = cpuTotalTicks;
     break;
   case 0x202:
     IF ^= (value & IF);
